
LVBM.AddOns.Nefarian = {
	["Name"] = LVBM_NEFARIAN_NAME,
	["Abbreviation1"] = "nef",
	["Version"] = "1.1",
	["Author"] = "Tandanu",
	["Description"] = LVBM_NEFARIAN_DESCRIPTION,
	["Instance"] = LVBM_BWL,
	["GUITab"] = LVBMGUI_TAB_BWL,
	["Sort"] = 8,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
--		["BlockHeals"] = true,
		["UnequipBow"] = true,
		["SyncKills"] = true,
	},
	["DropdownMenu"] = {
--[[	[1] = {
			["variable"] = "LVBM.AddOns.Nefarian.Options.BlockHeals",
			["text"] = LVBM_NEFARIAN_BLOCK_HEALS,
			["func"] = function() LVBM.AddOns.Nefarian.Options.BlockHeals = not LVBM.AddOns.Nefarian.Options.BlockHeals; end,
		},]]
		[1] = {
			["variable"] = "LVBM.AddOns.Nefarian.Options.UnequipBow",
			["text"] = LVBM_NEFARIAN_UNEQUIP_BOW,
			["func"] = function() LVBM.AddOns.Nefarian.Options.UnequipBow = not LVBM.AddOns.Nefarian.Options.UnequipBow; end,
		},
		[2] = {
			["variable"] = "LVBM.AddOns.Nefarian.Options.SyncKills",
			["text"] = LVBM_NEFARIAN_SYNCKILLS_INFO,
			["func"] = function() LVBM.AddOns.Nefarian.Options.SyncKills = not LVBM.AddOns.Nefarian.Options.SyncKills; end,
		},
	},
	["LocalDrakonids"] = { 
		[1] = 0, 
		[2] = 0, 
		[3] = 0, 
		[4] = 0, 
		[5] = 0, 
		[6] = 0, 
	},
	["SyncedDrakonids"] = { 
		[1] = 0, 
		[2] = 0, 
		[3] = 0, 
		[4] = 0, 
		[5] = 0, 
		[6] = 0, 
	},
	["SideColor"] = 0,
	["LastCountMsg"] = 0,
--	["PriestCall"] = false,
	["BowBag"]	= 0,
	["BowSlot"] = 0,
	["BowUnequipped"] = false,
	["Phase"] = 1,
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_ADDON"] = true,
		["CHAT_MSG_COMBAT_HOSTILE_DEATH"] = true,
	},
	["OnCombatStart"] = function(delay)
		for i = 1, 6 do
			LVBM.AddOns.Nefarian.LocalDrakonids[i] = 0;
		end
		for i = 1, 6 do
			LVBM.AddOns.Nefarian.SyncedDrakonids[i] = 0;
		end
		LVBM.AddOns.Nefarian.Phase = 1;
		
		if LVBM.SyncInfo and LVBM.SyncInfo.Clients then
			local goodVersionCounter = 0;
			for index, value in pairs(LVBM.SyncInfo.Clients) do
				if (tonumber(value) or 0) >= 2.2 then
					goodVersionCounter = goodVersionCounter + 1;
					if goodVersionCounter >= 2 then
						break;
					end
				end
			end
			
			if goodVersionCounter < 2 then
				LVBM.AddMsg(LVBM_NEFARIAN_ERROR_NO_SYNC);
			end
		end
	end,
	["OnCombatEnd"] = function()
		for i = 1, 6 do
			LVBM.AddOns.Nefarian.LocalDrakonids[i] = 0;
		end
		for i = 1, 6 do
			LVBM.AddOns.Nefarian.SyncedDrakonids[i] = 0;
		end
		LVBM.AddOns.Nefarian.SideColor = 0;
		LVBM.AddOns.Nefarian.LastCountMsg = 0;
	end,
	["OnEvent"] = function(event, arg1)


		if LVBM.AddOns.Nefarian.Options.SyncKills and event == "CHAT_MSG_ADDON" and arg1 == "LVNEF" and arg2 and arg3 == "RAID" and arg4 ~= UnitName("player") and (LVBM.AddOns.Nefarian.Phase == 1) then
			local count = 0;
			local syncKills = {};
			_, _, syncKills[1], syncKills[2], syncKills[3], syncKills[4], syncKills[5], syncKills[6] = string.find(arg2, "(%d+)~(%d+)~(%d+)~(%d+)~(%d+)~(%d+)~");
			
			for i = 1, 6 do
				if (tonumber(syncKills[i]) or 0) > LVBM.AddOns.Nefarian.SyncedDrakonids[i] then
					LVBM.AddOns.Nefarian.SyncedDrakonids[i] = (tonumber(syncKills[i]) or 0);
				end
			end
			
			for i = 1, 6 do
				if LVBM.AddOns.Nefarian.SyncedDrakonids[i] > LVBM.AddOns.Nefarian.LocalDrakonids[i] then
					count = count + LVBM.AddOns.Nefarian.SyncedDrakonids[i];
				else
					count = count + LVBM.AddOns.Nefarian.LocalDrakonids[i];
				end
			end
			
			if( count > 3 and (time() - LVBM.AddOns.Nefarian.LastCountMsg) > 10 ) then
				LVBM.AddOns.Nefarian.LastCountMsg = time();
				LVBM.Announce( string.format(LVBM_NEFARIAN_SYNCKILLS_ANNOUNCE, count) );
			end

		elseif LVBM.AddOns.Nefarian.Options.SyncKills and event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" and (LVBM.AddOns.Nefarian.Phase == 1) then
			local foundKill;
			for i = 1, 6 do
				if( LVBM_NEFARIAN_DRAKONID_DOWN[i] == arg1 ) then
					LVBM.AddOns.Nefarian.LocalDrakonids[i] = LVBM.AddOns.Nefarian.LocalDrakonids[i] + 1;
					foundKill = true;
					break;
				end
			end
			if not foundKill then
				return;
			end
			
			local syncString = "";
			for i = 1, 6 do
				syncString = syncString..tostring(LVBM.AddOns.Nefarian.LocalDrakonids[i]).."~";
--				LVBM.AddMsg(tostring(LVBM.AddOns.Nefarian.LocalDrakonids[i]), tostring(i));
			end
			
			
			SendAddonMessage("LVNEF", syncString, "RAID");

		elseif event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" then
			if arg1 == LVBM_NEFARIAN_CAST_SHADOW_FLAME then
				LVBM.Announce(LVBM_SHADOW_FLAME_WARNING);
				LVBM.StartStatusBarTimer(2, "Shadow Flame Cast", "Interface\\Icons\\Spell_Fire_Incinerate");
			elseif arg1 == LVBM_NEFARIAN_CAST_FEAR then
				LVBM.Announce(LVBM_NEFARIAN_FEAR_WARNING);
				LVBM.StartStatusBarTimer(1.5, "Fear Cast", "Interface\\Icons\\Spell_Shadow_PsychicScream");
			end
		elseif event == "CHAT_MSG_MONSTER_YELL" then
			if arg1 == LVBM_NEFARIAN_YELL_PHASE2 then
				LVBM.Announce(LVBM_NEFARIAN_PHASE2_WARNING);
				LVBM.AddOns.Nefarian.Phase = 2;
				LVBM.StartStatusBarTimer(15, "Phase 2");
			elseif arg1 == LVBM_NEFARIAN_YELL_PHASE3 then
				LVBM.Announce(LVBM_NEFARIAN_PHASE3_WARNING);
			elseif (string.find(arg1, LVBM_NEFARIAN_YELL_SHAMANS)) then
				LVBM.Announce(LVBM_NEFARIAN_SHAMAN_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Class call CD", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_PALAS then
				LVBM.Announce(LVBM_NEFARIAN_PALA_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Class call CD", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_DRUIDS then
				LVBM.Announce(LVBM_NEFARIAN_DRUID_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Druid call", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_PRIESTS then
				if UnitClass("player") == LVBM_PRIEST then
					LVBM.AddSpecialWarning(LVBM_NEFARIAN_PRIEST_CALL, true, true);
--					LVBM.AddOns.Nefarian.PriestCall = 30;
--					LVBM.Schedule(30, "LVBM.AddOns.Nefarian.OnEvent", "ResetPriestCall")
				end
				LVBM.Announce(LVBM_NEFARIAN_PRIEST_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Priest call", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_WARRIORS then
				LVBM.Announce(LVBM_NEFARIAN_WARRIOR_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Warrior call", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_ROGUES then
				LVBM.Announce(LVBM_NEFARIAN_ROGUE_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Rogue call", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_WARLOCKS then
				LVBM.Announce(LVBM_NEFARIAN_WARLOCK_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Class call CD", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_HUNTERS then
				LVBM.Announce(LVBM_NEFARIAN_HUNTER_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Class call CD", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_MAGES then
				LVBM.Announce(LVBM_NEFARIAN_MAGE_WARNING);
				LVBM.Schedule(27, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5)
				LVBM.EndStatusBarTimer("Class call CD");
				LVBM.StartStatusBarTimer(30, "Mage call", "Interface\\Icons\\Spell_Shadow_Charm");
				LVBM.AddOns.Nefarian.OnEvent("EquipBow");
			elseif arg1 == LVBM_NEFARIAN_YELL_DEAD then
				LVBM.UnSchedule("LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 5);
				LVBM.UnSchedule("LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 0);
			end
		elseif event == "ClassCallWarning" then
			if arg1 == 5 then
				LVBM.Announce(LVBM_NEFARIAN_CLASS_CALL_WARNING);
				LVBM.Schedule(3, "LVBM.AddOns.Nefarian.OnEvent", "ClassCallWarning", 0)
			elseif arg1 == 0 then
				if UnitClass("player") == LVBM_HUNTER and LVBM.AddOns.Nefarian.Options.UnequipBow then
					for i = 0, 4 do
						if GetContainerNumSlots(i) then
							for j = 1, GetContainerNumSlots(i) do
								if GetContainerItemInfo(i, j) == nil then
									ClearCursor();
									PickupInventoryItem(18);
									if CursorHasItem() then
										PickupContainerItem(i, j)
										LVBM.AddOns.Nefarian.BowBag = i;
										LVBM.AddOns.Nefarian.BowSlot = j;
										LVBM.AddOns.Nefarian.BowUnequipped = true;										
									else
										LVBM.AddMsg(LVBM_NEFARIAN_UNEQUIP_ERROR);
									end
									break;
								end
							end
							if LVBM.AddOns.Nefarian.BowUnequipped then
								break;
							end
						end
					end
				end
			end
		elseif event == "EquipBow" then
			if LVBM.AddOns.Nefarian.BowUnequipped then
				if GetContainerItemInfo(LVBM.AddOns.Nefarian.BowBag, LVBM.AddOns.Nefarian.BowSlot) then
					ClearCursor();
					PickupContainerItem(LVBM.AddOns.Nefarian.BowBag, LVBM.AddOns.Nefarian.BowSlot);
					if CursorHasItem() then
						PickupInventoryItem(18);	
						LVBM.AddOns.Nefarian.BowBag = 0;
						LVBM.AddOns.Nefarian.BowSlot = 0;
						LVBM.AddOns.Nefarian.BowUnequipped = false;
					else
						LVBM.AddMsg(LVBM_NEFARIAN_EQUIP_ERROR);
					end
				else
					LVBM.AddMsg(LVBM_NEFARIAN_EQUIP_ERROR);
				end
			end
--		elseif event == "ResetPriestCall" then
--			LVBM.AddOns.Nefarian.PriestCall = false;
		end
	end,
--[[["Hooks"] = {
		["oldUseAction"] = UseAction,
		["newUseAction"] = function(slot, checkCursor, onSelf)
			if type(LVBM.AddOns.Nefarian.PriestCall) == "number" and LVBM.AddOns.Nefarian.Options.BlockHeals then
				LVBMTooltipTextLeft1:SetText("");
				LVBMTooltip:SetAction(slot);
				if LVBMTooltipTextLeft1:GetText() and LVBM_NEFARIAN_BLOCKED_SPELLS[LVBMTooltipTextLeft1:GetText()] and LVBM_NEFARIAN_BLOCKED_SPELLS[LVBMTooltipTextLeft1:GetText()] <= LVBM.AddOns.Nefarian.PriestCall then
					LVBM.AddMsg(string.format(LVBM_NEFARIAN_HEAL_BLOCKED, LVBMTooltipTextLeft1:GetText()));
					return;
				else
					LVBM.AddOns.Nefarian.Hooks.oldUseAction(slot, checkCursor, onSelf);
				end				
			end
			LVBM.AddOns.Nefarian.Hooks.oldUseAction(slot, checkCursor, onSelf);
		end,
		["oldCastSpellByName"] = CastSpellByName,
		["newCastSpellByName"] = function(spell, onSelf)
			if type(LVBM.AddOns.Nefarian.PriestCall) == "number" and LVBM.AddOns.Nefarian.Options.BlockHeals then
				local cleanSpell;
				cleanSpell = string.gsub(spell, "%((%w+) (%d+)%)", "");
				if cleanSpell and LVBM_NEFARIAN_BLOCKED_SPELLS[cleanSpell] and LVBM_NEFARIAN_BLOCKED_SPELLS[cleanSpell] <= LVBM.AddOns.Nefarian.PriestCall then
					LVBM.AddMsg(string.format(LVBM_NEFARIAN_HEAL_BLOCKED, cleanSpell));
					return;
				else
					LVBM.AddOns.Nefarian.Hooks.oldCastSpellByName(spell, onSelf);
				end
			end
			LVBM.AddOns.Nefarian.Hooks.oldCastSpellByName(spell, onSelf);
		end,
	},
	["OnUpdate"] = function(elapsed)
		if type(LVBM.AddOns.Nefarian.PriestCall) == "number" then
			LVBM.AddOns.Nefarian.PriestCall = LVBM.AddOns.Nefarian.PriestCall - elapsed;
			if LVBM.AddOns.Nefarian.PriestCall <= 0 then
				LVBM.AddOns.Nefarian.PriestCall = false;
			end
		end
	end]]
};

--[[local version, build, date = GetBuildInfo();
if tonumber(string.sub(version, 0, 3)) < 2 then
	UseAction 		= LVBM.AddOns.Nefarian.Hooks.newUseAction;
	CastSpellByName	= LVBM.AddOns.Nefarian.Hooks.newCastSpellByName;
end]]