--
-- La Vendetta Instructor Razuvious Raid Warning AddOn
-- (c) by Nitram from La Vendetta on DE-Azshara
--
local BossMod = LVBM:NewBossMod("Razuvious", LVBM_IR_NAME, LVBM_IR_DESCRIPTION, LVBM_NAXX, LVBMGUI_TAB_NAXX, 21);

BossMod.Author 			= "Nitram";
BossMod.Version			= "1.7";
BossMod.Lastshout		= 0;
BossMod.LastAnnounce	= 0;

BossMod:AddOption("10SecWarning", false, LVBM_IR_SHOW_10SEC_WARNING)

BossMod:RegisterEvents("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");

function BossMod:OnCombatStart(delay)
	self:Announce(string.format(LVBM_IR_SHOUT_WARNING, 5));	
	LVBM.StartStatusBarTimer(5, "Disrupting Shout", "Interface\\Icons\\Ability_Warrior_RallyingCry");
	LVBM.Schedule(5, function() 
		LVBM.AddOns.Razuvious:OnEvent("StartNewDShoutTimer");
		LVBM.StartRepeatingStatusBarTimer(25, "Disrupting Shout", "Interface\\Icons\\Ability_Warrior_RallyingCry");
	end);
end

function BossMod:OnEvent(event, args)
		if ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or 				
			 event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or
			 event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" ) then
			
			if( string.find(arg1, LVBM_IR_SPELL_1) )then
				if( self.Lastshout > 0 and math.floor(GetTime() - self.Lastshout) > 0 ) then
					self.InCombat = true;
					self:AddMsg(LVBM_IR_TIMER_UPDATED);
					
					self:OnEvent("StartNewDShoutTimer");
					self.Lastshout = GetTime();
					LVBM.EndRepeatingStatusBarTimer("Disrupting Shout");
					LVBM.StartRepeatingStatusBarTimer(25, "Disrupting Shout", "Interface\\Icons\\Ability_Warrior_RallyingCry");
				else
					self:OnEvent("StartNewDShoutTimer");
					self.Lastshout = GetTime();
				end
			end
		end
			
		if (event == "StartNewDShoutTimer") then
			if (GetTime() - self.Lastshout) < 2  then return true; end	-- Don't need Spam
				
			LVBM.UnSchedule("LVBM.AddOns.Razuvious:OnEvent");			-- Don't need the Loop & Warnings
				
			if (GetTime() - self.LastAnnounce) > 4 then
				self:Announce(string.format(LVBM_IR_SHOUT_WARNING, 25));		-- Callout Warning
				self.LastAnnounce = GetTime();
			end
			LVBM.Schedule(15, "LVBM.AddOns.Razuvious:OnEvent", "DShout10SecWarning");			-- Schedule Warnings
			LVBM.Schedule(20, "LVBM.AddOns.Razuvious:OnEvent", "DShout5SecWarning");
			LVBM.Schedule(22, "LVBM.AddOns.Razuvious:OnEvent", "DShout3SecWarning");
				
		elseif (event == "DShout10SecWarning") and self.Options["10SecWarning"] then
			self:Announce(string.format(LVBM_IR_SHOUT_WARNING, 10));
			
		elseif (event == "DShout5SecWarning") then
			self:Announce(string.format(LVBM_IR_SHOUT_WARNING, 5));
			
		elseif (event == "DShout3SecWarning") then

			LVBM.Schedule(3, "LVBM.AddOns.Razuvious:OnEvent", "StartNewDShoutTimer");			-- Schedule Loop
		end
end