--
--  Sapphiron - v1.0 by Nitram
--

LVBM.AddOns.Sapphiron = {
	["Name"] = LVBM_SAPPHIRON_NAME,
	["Abbreviation1"] = "sapphiron",
	["Version"] = "1.0",
	["Author"] = "Nitram",
	["Description"] = LVBM_SAPPHIRON_INFO,
	["Instance"] = LVBM_NAXX,
	["GUITab"] = LVBMGUI_TAB_NAXX,
	["Sort"] = 51,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["Yell"] = true,
		["ShowPings"] = true,
		["ShowDistanceFrame"] = true,
	},
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Sapphiron.Options.Yell",
			["text"] = LVBM_SAPPHIRON_YELL_INFO,
			["func"] = function() LVBM.AddOns.Sapphiron.Options.Yell = not LVBM.AddOns.Sapphiron.Options.Yell; end,
		},
		[2] = {
			["variable"] = "LVBM.AddOns.Sapphiron.Options.ShowPing",
			["text"] = LVBM_SAPPHIRON_PING_INFO,
			["func"] = function()
				LVBM.AddOns.Sapphiron.Options.ShowPing = not LVBM.AddOns.Sapphiron.Options.ShowPing;
				if LVBM.AddOns.Sapphiron.InCombat then
					LVBM.AddOns.Sapphiron.HidePings((not LVBM.AddOns.Sapphiron.Options.ShowPing));
				end
			end,
		},
		[3] = {
			["variable"] = "LVBM.AddOns.Sapphiron.Options.ShowDistanceFrame",
			["text"] = LVBM_SAPPHIRON_SHOW_DISTANCE_FRAME,
			["func"] = function() LVBM.AddOns.Sapphiron.Options.ShowDistanceFrame = not LVBM.AddOns.Sapphiron.Options.ShowDistanceFrame	end,
		},
	},
	["Events"] = {
		["CHAT_MSG_MONSTER_EMOTE"] = true,				-- IceBomb
		["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] = true,		-- LifeDrain
		["CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"] = true,	-- LifeDrain
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,			-- LifeDrain // Icebolt
		["CHAT_MSG_SPELL_AURA_GONE_SELF"] = true,			-- Icebolt
	},
	["LastDrain"] = 0,
	["LastDeepBreath"] = 0,
	["InCombat"] = false, 
	["OnCombatStart"] = function(delay)
		LVBM.Schedule(810 - delay, "LVBM.AddOns.Sapphiron.OnEvent", "EnrageWarning", 90);
		LVBM.Schedule(870 - delay, "LVBM.AddOns.Sapphiron.OnEvent", "EnrageWarning", 30);
		LVBM.StartStatusBarTimer(900 - delay, "Enrage", "Interface\\Icons\\Spell_Shadow_UnholyFrenzy");
		LVBM.StartStatusBarTimer(10 - delay, "Life Drain", "Interface\\Icons\\Spell_Shadow_LifeDrain02");
		LVBM.AddOns.Sapphiron.HidePings((not LVBM.AddOns.Sapphiron.Options.ShowPing));
		LVBM.AddOns.Sapphiron.InCombat = true;
		
		
		LVBM.StartStatusBarTimer(44 - delay, "Air Phase", "Interface\\AddOns\\LVBM_API\\Textures\\CryptFiendUnBurrow");
	end,
	["OnCombatEnd"] = function()
		LVBM.AddOns.Sapphiron.InCombat = false;
		LVBM.AddOns.Sapphiron.PingStartedTime = 0;
		LVBM.UnSchedule("LVBM.AddOns.Sapphiron.OnEvent", "EnrageWarning");
		LVBM.UnSchedule("LVBM.AddOns.Sapphiron.PingMiniMap");
		LVBM.AddOns.Sapphiron.HidePings(false);
	end,
	["TargetTime"] = 0,
	["LastTarget"] = "",
	["OnUpdate"] = function(elapsed)
		if (not LVBM.AddOns.Sapphiron.InCombat) then  return; end

		local FoundSapphiron = false;
		local newTarget;
			
		if (UnitName("target") == LVBM_SAPPHIRON_NAME) and UnitAffectingCombat("target") then
			newTarget = UnitName("targettarget")
			FoundSapphiron = true;
		else
			for i = 1, GetNumRaidMembers() do
				if (UnitName("raid"..i.."target") == LVBM_SAPPHIRON_NAME) and UnitAffectingCombat("raid"..i.."target") then
					newTarget = UnitName("Raid"..i.."targettarget")
					FoundSapphiron = true;
					break;
				end
			end
		end
		if (FoundSapphiron) then
			if (newTarget == LVBM.AddOns.Sapphiron.LastTarget) then
				LVBM.AddOns.Sapphiron.TargetTime = LVBM.AddOns.Sapphiron.TargetTime + elapsed;
			else
				LVBM.AddOns.Sapphiron.LastTarget = newTarget;
				LVBM.AddOns.Sapphiron.TargetTime = 0;
			end

			if (not newTarget and LVBM.AddOns.Sapphiron.TargetTime > 2 and (GetTime() - LVBM.AddOns.Sapphiron.LastDeepBreath) > 37) then
				LVBM.StartStatusBarTimer(29.25, "Deep Breath", "Interface\\Icons\\Spell_Frost_FrostNova");
				LVBM.EndStatusBarTimer("Life Drain");
				LVBM.EndStatusBarTimer("Air Phase");
				
				LVBM.AddOns.Sapphiron.LastDeepBreath = GetTime();
				
				if LVBM.AddOns.Sapphiron.Options.ShowDistanceFrame then
					LVBM_Gui_DistanceFrame_Show();
				end
			end
		end
	end,
	["UpdateInterval"] = 0.2,
	["PingStartedTime"] = 0,
	["PingMiniMap"] = function()
		if( (time() - LVBM.AddOns.Sapphiron.PingStartedTime) < 30 ) then	-- Protect Ping Spam !! :)
			Minimap:PingLocation(CURSOR_OFFSET_X, CURSOR_OFFSET_Y);
			LVBM.Schedule(2, "LVBM.AddOns.Sapphiron.PingMiniMap");		-- Ping all 2 sec
		else
			LVBM.AddOns.Sapphiron.PingStartedTime = 0;
		end
	end,
	["HidePings"] = function(value)
		if value then
			Minimap_SetPing = function() end;
		else
			Minimap_SetPing = LVBM.Hooks.oldMinimap_SetPing;
		end
	end,
	["OnEvent"] = function(event, arg1)
		-------------------------
		-- Icebolt PingMinimap --
		-------------------------
		if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" and string.find(arg1, LVBM_SAPPHIRON_FROSTBOLT_GAIN_EXPR)) then
			LVBM.AddOns.Sapphiron.PingStartedTime = time();
			LVBM.AddOns.Sapphiron.PingMiniMap();

			if( LVBM.AddOns.Sapphiron.Options.Yell ) then
				SendChatMessage( LVBM_SAPPHIRON_YELL_ANNOUNCE, "YELL");
			end

		elseif (event == "CHAT_MSG_SPELL_AURA_GONE_SELF" and string.find(arg1, LVBM_SAPPHIRON_FROSTBOLT_FADE_EXPR)) then
			LVBM.UnSchedule("LVBM.AddOns.Sapphiron.PingMiniMap");
		end
		
		---------------------
		-- Enrage Warnings --
		---------------------
		if (event == "EnrageWarning") then
			LVBM.Announce(string.format(LVBM_SAPPHIRON_ENRAGE_ANNOUNCE, arg1));
		end

		------------------------
		-- Life Drain Warning --
		------------------------
		if ((event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"
		 or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"
		 or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE")
		 and (time() - LVBM.AddOns.Sapphiron.LastDrain) > 5 
		 and (string.find(arg1, LVBM_SAPPHIRON_LIFEDRAIN_EXPR1) 
		   or string.find(arg1, LVBM_SAPPHIRON_LIFEDRAIN_EXPR2)) ) then
			LVBM.AddOns.Sapphiron.LastDrain = time();
			LVBM.Announce(LVBM_SAPPHIRON_LIFEDRAIN_ANNOUNCE);
			LVBM.Schedule(19, "LVBM.AddOns.Sapphiron.OnEvent", "LifeDrainWarn", 5);
			LVBM.StartStatusBarTimer(24, "Life Drain", "Interface\\Icons\\Spell_Shadow_LifeDrain02");
			
		elseif (event == "LifeDrainWarn") then
			LVBM.Announce(string.format(LVBM_SAPPHIRON_LIFEDRAIN_WARN, arg1));
		end

		-----------------
		-- Deep Breath --
		-----------------
		if (event == "CHAT_MSG_MONSTER_EMOTE" and string.find(arg1, LVBM_SAPPHIRON_DEEPBREATH_EXPR)) then
			LVBM.Announce(LVBM_SAPPHIRON_DEEPBREATH_ANNOUNCE);
			
			
			LVBM.Schedule(7, "LVBM.AddOns.Sapphiron.DeepBreath");

			
			
			if not LVBM.GetStatusBarTimerTimeLeft("Deep Breath") then
				LVBM.StartStatusBarTimer(29.25, "Deep Breath", "Interface\\Icons\\Spell_Frost_FrostNova");
			end			
			
			LVBM.UpdateStatusBarTimer("Deep Breath", 22.25, 29.25);			
		end
	end,
	["DeepBreath"] = function()
		if LVBM.AddOns.Sapphiron.Options.ShowDistanceFrame then
			LVBM_Gui_DistanceFrame_Hide();
		end
		
		LVBM.StartStatusBarTimer(66.5, "Air Phase", "Interface\\AddOns\\LVBM_API\\Textures\\CryptFiendUnBurrow");
	end
};


LVBM.Hooks.oldMinimap_SetPing = Minimap_SetPing;