--
-- La Vendetta Noth the Plaguebringer Raid Warning AddOn
-- (c) by Nitram from La Vendetta on DE-Azshara
--
-- Edited Hye/Ajaaja of Kilrogg (first blink timer and spawn warning during balcony phase) - thank you!

local BossMod = LVBM:NewBossMod("Noth", LVBM_NTP_NAME, LVBM_NTP_DESCRIPTION, LVBM_NAXX, LVBMGUI_TAB_NAXX, 31);

BossMod.Author 			= "Nitram";
BossMod.Version			= "1.7";
BossMod.Phase			= 1;
BossMod.LastCurse		= 0;
BossMod.TimeOnBalcony	= 70;
BossMod.TimeInRoom		= 90;
BossMod.OnBalcony		= false;


BossMod:AddOption("AnnounceSpawn", false, LVBM_NTP_OPTION_WARN_SPAWN)
BossMod:AddOption("AnnounceCurse", true, LVBM_NTP_OPTION_WARN_CURSE)

BossMod:RegisterEvents("CHAT_MSG_MONSTER_YELL",
					"CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS",
					"CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS",
					"CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE",
					"CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE");

function BossMod:OnEvent(event, arg1)
	if (event == "CHAT_MSG_MONSTER_YELL" and ((arg1 == LVBM_NTP_YELL_START1) 
										or (arg1 == LVBM_NTP_YELL_START2) 
										or (arg1 == LVBM_NTP_YELL_START3))) 
	  or (event == "BACKINROOM") then

		self.InCombat = true;
		self.OnBalcony = false;					
		if (event == "BACKINROOM") then
			LVBM.Announce(string.format(LVBM_NTP_BACK_WARNING, self.TimeInRoom));
		else
			self.TimeOnBalcony = 70;
			self.TimeInRoom = 90;
			LVBM.Announce(string.format(LVBM_NTP_TELEPORT_WARNING, self.TimeInRoom));
			LVBM.Schedule(25, "LVBM.AddOns.Noth:OnEvent", "NTP5SecWarningBlink");
			LVBM.Schedule(30, "LVBM.AddOns.Noth:OnEvent", "NTP0SecWarningBlink");
			LVBM.StartStatusBarTimer(30, "Blink Cooldown", "Interface\\Icons\\Spell_Arcane_Blink");
		end
		LVBM.Schedule((self.TimeInRoom-10), "LVBM.AddOns.Noth:OnEvent", "NTP10SecWarningTeleport");
		LVBM.Schedule(self.TimeInRoom, "LVBM.AddOns.Noth:OnEvent", "NTPGoToBalcony");
		LVBM.StartStatusBarTimer(self.TimeInRoom, "Teleport to Balcony", "Interface\\Icons\\Spell_Arcane_Blink");
	end

	if( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then			
		if arg1 == LVBM_NTP_SPELL_1 then
			LVBM.Announce(LVBM_NTP_NOTH_GAINS_BLINK);
			LVBM.Schedule(25, "LVBM.AddOns.Noth:OnEvent", "NTP5SecWarningBlink");
			LVBM.EndStatusBarTimer("Blink");
			LVBM.StartStatusBarTimer(30, "Blink", "Interface\\Icons\\Spell_Arcane_Blink");
		end
	end

	if( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" 
	 or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" 
	 or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" ) then

		if (self.Options.AnnounceCurse 
		and (time() > (self.LastCurse+10) )
		and string.find(arg1, LVBM_NTP_CURSE_AFFLICT)) then

			self.LastCurse = time();
			LVBM.Announce(LVBM_NTP_CURSE_WARNING);
			
			LVBM.StartStatusBarTimer(9, "Curse Timeout", "Interface\\Icons\\Spell_Shadow_AnimateDead");
		end
	end
	
	if( event == "CHAT_MSG_MONSTER_YELL" and (string.find(arg1, LVBM_NTP_ADDS_SPAWN))) and self.Options.AnnounceSpawn then
		LVBM.Announce(LVBM_NTP_ADD_WARNING);
	end
		
	if (event == "NTP5SecWarningBlink") then							-- Blink System
		LVBM.Announce(LVBM_NTP_BLINK_5SEC_WARNING);
	elseif (event == "NTP0SecWarningBlink") then
		LVBM.Announce(LVBM_NTP_BLINK_0SEC_WARNING);	
	elseif (event == "NTP10SecWarningTeleport") then
		LVBM.Announce(LVBM_NTP_TELEPORT_10SEC_WARNING);				
	elseif (event == "NTP10SECUNTILBACK" ) then
		LVBM.Announce(LVBM_NTP_BACK_10SEC_WARNING);
	elseif (event == "NTP10SecWarningWave2") then
		LVBM.Announce(LVBM_NTP_NEXT_WAVE_SOON);
		
	elseif (event == "NTPGoToBalcony" ) then
		self.OnBalcony = true;
		LVBM.Schedule((self.TimeOnBalcony-10), "LVBM.AddOns.Noth:OnEvent", "NTP10SECUNTILBACK");
		LVBM.Schedule(self.TimeOnBalcony, "LVBM.AddOns.Noth:OnEvent", "BACKINROOM");
		LVBM.StartStatusBarTimer(self.TimeOnBalcony, "Teleport back", "Interface\\Icons\\Spell_Arcane_Blink");
		if (self.TimeOnBalcony == 70 ) then
			self.Phase = 1;
			self.TimeOnBalcony = 95;
			self.TimeInRoom = 110;
			-- Wave1/Wave2 Announce/Scheduling
			LVBM.Schedule(30, "LVBM.AddOns.Noth:OnEvent", "NTP10SecWarningWave2");
			LVBM.StartStatusBarTimer(10, "Wave 1", "Interface\\Icons\\Spell_Shadow_RaiseDead");
			LVBM.StartStatusBarTimer(40, "Wave 2", "Interface\\Icons\\Spell_Shadow_RaiseDead");
		elseif (self.TimeOnBalcony == 95) then
			self.Phase = 2;
			self.TimeOnBalcony = 120;
			self.TimeInRoom = 180;
			-- Wave1/Wave2 Announce/Scheduling
			LVBM.Schedule(45, "LVBM.AddOns.Noth:OnEvent", "NTP10SecWarningWave2");
			LVBM.StartStatusBarTimer(10, "Wave 1", "Interface\\Icons\\Spell_Shadow_RaiseDead");
			LVBM.StartStatusBarTimer(55, "Wave 2", "Interface\\Icons\\Spell_Shadow_RaiseDead");
		end

		LVBM.EndStatusBarTimer("Blink");
		LVBM.UnSchedule("LVBM.AddOns.Noth:OnEvent", "NTP5SecWarningBlink");
	end
end