--
-- Alterac und Arathi Battleground Mods
--
-- based on v1.0 from LeoLeal,  thanks
-- by Nitram to v1.2 with auto turn-In for alterac valley
-- by Nitram to v1.4 with Arathi Basin Time to End Bar, bugfixes etc.
-- by Nitram to v1.5 with WSG Flag Info Frame and a lot of Bugfixes.
-- by Nitram to v1.6 with only Local Bars, Option to change "bar" text, Colored Bars
-- by Nitram to v1.7 - changed localizations
--

LVBM.AddOns.Battlegrounds = { 
	["Name"] = LVBM_BGMOD_LANG.NAME, 
	["Abbreviation1"] = "bg", 
	["Version"] = "1.7", 
	["Author"] = "Nitram + LeoLeal", 
	["Description"] = LVBM_BGMOD_LANG.INFO,
	["Instance"] = LVBM_OTHER, 
	["GUITab"] = LVBMGUI_TAB_OTHER, 
	["Sort"] = 0, 
	["Options"] = {
		["Enabled"] = true, 
		["Announce"] = false, 
		["AVAutoTurnIn"] = true, 
		["ShowWsgFrame"] = true,
		["ColorByClass"] = true,
		["ShowInviteTimer"] = true,
	}, 
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn", 
			["text"] = LVBM_BGMOD_LANG.AV_TURNININFO, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn = not LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn; end, 
		}, 
		[2] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame", 
			["text"] = LVBM_BGMOD_LANG.WSG_INFOFRAME_INFO, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame = not LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame; end, 
		}, 
		[3] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.ColorByClass", 
			["text"] = LVBM_BGMOD_LANG.COLOR_BY_CLASS, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.ColorByClass = not LVBM.AddOns.Battlegrounds.Options.ColorByClass; end, 
		},
		[4] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.ShowInviteTimer", 
			["text"] = LVBM_BGMOD_LANG.SHOW_INV_TIMER, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.ShowInviteTimer = not LVBM.AddOns.Battlegrounds.Options.ShowInviteTimer; end, 
		},
	}, 
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true,
		["CHAT_MSG_BG_SYSTEM_NEUTRAL"] = true,
		["CHAT_MSG_BG_SYSTEM_ALLIANCE"] = true, 
		["CHAT_MSG_BG_SYSTEM_HORDE"] = true, 
		["PLAYER_ENTERING_WORLD"] = true,
		["ZONE_CHANGED_NEW_AREA"] = true,
		["GOSSIP_SHOW"] = true, 			-- Turn In
		["QUEST_PROGRESS"] = true, 			-- Turn In
		["QUEST_COMPLETE"] = true, 			-- Turn In
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,	-- WSG Boots Timer
		["UPDATE_BATTLEFIELD_SCORE"] = true, 
	}, 	
	["GetItemName"] = function(bag,  slot)
		local itemlink;
		if (bag == -1) then	itemlink = GetInventoryItemLink("player",  slot);
		else			itemlink = GetContainerItemLink(bag,  slot);
		end
		if (itemlink) then
			local _,  _,  name = string.find(itemlink,  "^.*%[(.*)%].*$");
			return name;
		else	return "";
		end
	end, 
	["GetItemCount"] = function(ItemName)
		local anzl,  bagNr,  bagSlot = 0;
		for bagNr = 0,  10,  1 do
			for bagSlot = 1,  GetContainerNumSlots(bagNr),  1 do
				if( LVBM.AddOns.Battlegrounds.GetItemName(bagNr,  bagSlot) == ItemName) then
					local _,  itemCount = GetContainerItemInfo(bagNr,  bagSlot);
					anzl = anzl + itemCount;
				end
			end
		end
		return anzl;
	end, 
	["ABGetScore"] = function()		-- LVBM.AddOns.Battlegrounds.ABGetScore
		if( GetRealZoneText() == LVBM_BGMOD_LANG.AB_ZONE ) then
			local _, mAllyInfo = GetWorldStateUIInfo(1);
			local _, mHordeInfo = GetWorldStateUIInfo(2);
			if( not mAllyInfo or not mHordeInfo ) then return false; end

			local _, _, AllyBases, AllyScore = string.find(mAllyInfo, LVBM_BGMOD_LANG.AB_SCOREEXP);
			local _, _, HordeBases, HordeScore = string.find(mHordeInfo, LVBM_BGMOD_LANG.AB_SCOREEXP);
			if( not AllyBases or not AllyScore or not HordeBases or not HordeScore) then return false; end

			AllyBases	= tonumber( AllyBases );
			AllyScore	= tonumber( AllyScore );
			HordeBases	= tonumber( HordeBases );
			HordeScore	= tonumber( HordeScore );

			return true, AllyBases, AllyScore, HordeBases, HordeScore;
		else return false;
		end
	end,
	["ABLastTick"] = {
		["LastAllyCount"] = 0,
		["LastHordeCount"] = 0,
		["Alliance"] = {
			["Score"] = 0,
			["Time"] = 0,
			["Bases"] = 0,
		},
		["Horde"] = {
			["Score"] = 0,
			["Time"] = 0,
			["Bases"] = 0,
		},
	},
	["ABResPerSec"] = function(bases)
		bases = tonumber(bases);
		local value = 0.0;		-- Used values from BGAssist because my times where wrong
		if(bases == 1) then	value = 25.0 / 30.0;		-- 25 res per 30 sec
		elseif(bases == 2) then	value = (300.0 / 9.0) / 30.0; 	-- 33.3(repeating) per 30 sec
		elseif(bases == 3) then	value = 50.0  / 30.0;		-- 50 res per 30 sec
		elseif(bases == 4) then	value = 100.0 / 30.0;		-- 100 res per 30 sec
		elseif(bases == 5) then	value = 900.0 / 30.0;		-- 900 res per 30 sec
		end
		return value;
	end,
	["WSGInfoFrame"] = function(showframe)
		if( LVBMWsgInfoFrame ) then
			if( LVBMWsgInfoFrame:GetObject():IsShown() and not showframe ) then	LVBMWsgInfoFrame:Hide();
			elseif( showframe ) then 						LVBMWsgInfoFrame:Show(); end
		elseif( showframe ) then
			LVBM.AddOns.Battlegrounds.WSGInfoFrameCreate();
		end		
	end,
	["WSGInfoFrameCreate"] = function()
		LVBMWsgInfoFrame = LVBMGui:CreateInfoFrame(LVBM_BGMOD_LANG.WSG_INFOFRAME_TITLE, LVBM_BGMOD_LANG.WSG_INFOFRAME_TEXT);
		if( not LVBMWsgInfoFrame ) then 
			LVBM.AddMsg("Can't get Frame from CreateInfoFrame()");
			return false; 
		end

		LVBMWsgInfoFrameAllianceFlag 	= LVBMWsgInfoFrame:CreateStatusBar(0, 1, 1, LVBM_BGMOD_LANG.WSG_ALLYFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
		LVBMWsgInfoFrameAllianceFlag:GetObject():SetStatusBarColor(0,0,1);
		LVBMWsgInfoFrameAllianceFlag:GetObject():EnableMouse(true);
		LVBMWsgInfoFrameAllianceFlag:GetObject():SetScript("OnMouseUp", function() 
--								TargetByName(LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1], true); 
							end);

		LVBMWsgInfoFrameHordeFlag 	= LVBMWsgInfoFrame:CreateStatusBar(0, 1, 1, LVBM_BGMOD_LANG.WSG_HORDEFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
		LVBMWsgInfoFrameHordeFlag:GetObject():SetStatusBarColor(1,0,0);
		LVBMWsgInfoFrameHordeFlag:GetObject():EnableMouse(true);
		LVBMWsgInfoFrameHordeFlag:GetObject():SetScript("OnMouseUp", function() 
--								TargetByName(LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2], true); 
							end);
	end,
	["WSGInfoFrameTarget"] = { [1] = "", [2] = "" },
	["OnUpdate"] = function(elapsed)
		if( GetRealZoneText() == LVBM_BGMOD_LANG.AB_ZONE ) then
			local mOk, AllyBases, AllyScore, HordeBases, HordeScore = LVBM.AddOns.Battlegrounds.ABGetScore();



			if( mOk and LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score ~= AllyScore ) then		-- Update Time on Score Change
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score = AllyScore;
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases = AllyBases;
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Time = time();
			end
			if( mOk and LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score ~= HordeScore ) then
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score = HordeScore;
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases = HordeBases;
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Time = time();
			end
		end
		
		
		--invite timer stuff
		if MAX_BATTLEFIELD_QUEUES and PVP_TEAMSIZE and LVBM.AddOns.Battlegrounds.Options.ShowInviteTimer then
			for i = 1, MAX_BATTLEFIELD_QUEUES do
				local status, mapName, instanceID, _, _, teamSize = GetBattlefieldStatus(i);
				if (mapName and (instanceID ~= 0)) then
					mapName = mapName.." "..instanceID;
					if (teamSize ~= 0) then
						mapName = mapName.." "..format(PVP_TEAMSIZE, tostring(teamSize), tostring(teamSize));
					end
				end
				if status == "confirm" then
					if not LVBM.GetStatusBarTimerTimeLeft(mapName) then
						LVBM.StartStatusBarTimer((GetBattlefieldPortExpiration(i)/1000), mapName, nil, true);
					end
				end
			end
		end
		
		
	end,
	["OnEvent"] = function(event,  arg1)

		if(event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" and string.find(arg1, LVBM_BGMOD_LANG.WSG_BOOTS_EXPR) )then
			LVBM.StartStatusBarTimer(10, "Speed Boots", nil, true);
			-- Respawn Timer seems to be around 165-175 Seconds (dynamic)
			return;	-- no other code needs this event
		end

		-- ------------------------ --
		-- WSG InfoFrame - FlagCaps --
		-- ------------------------ --
		if( event == "ZONE_CHANGED_NEW_AREA" and GetRealZoneText() == LVBM_BGMOD_LANG.WSG_ZONE ) and LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame then
			LVBM.AddOns.Battlegrounds.WSGInfoFrame(true);

		elseif( event == "ZONE_CHANGED_NEW_AREA" and GetRealZoneText() ~= LVBM_BGMOD_LANG.WSG_ZONE and LVBMWsgInfoFrame ) then
			LVBM.AddOns.Battlegrounds.WSGInfoFrame(false);
		end

		if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE" or event == "CHAT_MSG_BG_SYSTEM_HORDE") and LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame then
			if( LVBMWsgInfoFrame ) then
				if( string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_PICKUP) ) then
					local _, _, sArg1, sArg2 =  string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_PICKUP);
					local mSide, mNick;
					-- I don't know how to set Expression Capture Index for string.find :(
					if( GetLocale() == "deDE" ) then 	mSide = sArg2; mNick = sArg1;
					else					mSide = sArg1; mNick = sArg2;
					end
					if( mSide == LVBM_BGMOD_LANG.ALLIANCE ) then
						LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..mNick);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = mNick;

					elseif( mSide == LVBM_BGMOD_LANG.HORDE ) then
						LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..mNick);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = mNick;
					end
	
				elseif( string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_RETURN) ) then
					local _, _, mSide, mNick =  string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_RETURN);
					if( mSide == LVBM_BGMOD_LANG.ALLIANCE ) then
						LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = "";

					elseif( mSide == LVBM_BGMOD_LANG.HORDE ) then
						LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = "";
					end

				elseif( string.find(arg1, LVBM_BGMOD_LANG.WSG_HASCAPTURED) ) then	-- get point
					LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
					LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
					LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = "";
					LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = "";
				end
			end
		end

		----------------
		-- AB WinTime --
		----------------
		if( GetRealZoneText() == LVBM_BGMOD_LANG.AB_ZONE ) then

		  	if( LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score < 2000 
			and LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score < 2000
			and (LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score + LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score) > 0
			and (LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases + LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases) > 0 ) then

				if( LVBM.AddOns.Battlegrounds.ABLastTick.LastAllyCount ~= LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases 
				 or LVBM.AddOns.Battlegrounds.ABLastTick.LastHordeCount ~= LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases ) then
					LVBM.Schedule(2, "LVBM.AddOns.Battlegrounds.OnEvent", "GetNewABTimes");		-- Try this because the GetScore()
																								-- isn't synced and this sucks :(
				end
			end
		else 
			-- AB TimeLeft
			LVBM.EndStatusBarTimer("AB_WINALLY", true);
			LVBM.EndStatusBarTimer("AB_WINHORDE", true);
		end
		if( event == "GetNewABTimes" ) then
--				LVBM.AddMsg("GetNewABTimes", "DEBUG");
				
				local AllyTime = ((2000 - LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score) 
				            / LVBM.AddOns.Battlegrounds.ABResPerSec(LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases))
					    - (time()-LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Time);

				local HordeTime = ((2000 - LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score) 
				             / LVBM.AddOns.Battlegrounds.ABResPerSec(LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases))
					     - (time()-LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Time);
				
				
				if( AllyTime > 5000 ) then 	AllyTime = 5000; end
				if( HordeTime > 5000 ) then 	HordeTime = 5000; end
				
--				LVBM.AddMsg("Ally: "..AllyTime, "DEBUG");
--				LVBM.AddMsg("Horde: "..HordeTime, "DEBUG");
				
				LVBM.AddOns.Battlegrounds.ABLastTick.LastAllyCount = LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases; 
				LVBM.AddOns.Battlegrounds.ABLastTick.LastHordeCount = LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases;

				if LVBM.GetStatusBarTimerTimeLeft("AB_WINALLY") and LVBM.GetStatusBarTimerTimeLeft("AB_WINHORDE") then --bad timers, synced by bugged clients
					LVBM.EndStatusBarTimer("AB_WINALLY");
					LVBM.EndStatusBarTimer("AB_WINHORDE");
				end
				
				if( AllyTime == HordeTime ) then
					LVBM.EndStatusBarTimer("AB_WINALLY", true);
					LVBM.EndStatusBarTimer("AB_WINHORDE", true);

				elseif( AllyTime > HordeTime ) then		-- Horde wins!
					if( LVBM.GetStatusBarTimerTimeLeft("AB_WINALLY") ) then
						local timeLeft, timeElapsed = LVBM.GetStatusBarTimerTimeLeft("AB_WINALLY");
						LVBM.UpdateStatusBarTimer("AB_WINALLY", nil, (timeElapsed + HordeTime), "AB_WINHORDE", true);
						
					elseif( LVBM.GetStatusBarTimerTimeLeft("AB_WINHORDE") ) then
						local timeLeft, timeElapsed = LVBM.GetStatusBarTimerTimeLeft("AB_WINHORDE");
						LVBM.UpdateStatusBarTimer("AB_WINHORDE", nil, (timeElapsed + HordeTime), nil, true);
						
					else
						LVBM.StartStatusBarTimer(HordeTime, "AB_WINHORDE", nil, true);
					end

				elseif( HordeTime > AllyTime ) then		-- Alliance wins!
					if( LVBM.GetStatusBarTimerTimeLeft("AB_WINHORDE") ) then
						local timeLeft, timeElapsed = LVBM.GetStatusBarTimerTimeLeft("AB_WINHORDE");
						LVBM.UpdateStatusBarTimer("AB_WINHORDE", nil, (timeElapsed + AllyTime), "AB_WINALLY", true);

					elseif( LVBM.GetStatusBarTimerTimeLeft("AB_WINALLY") ) then
						local timeLeft, timeElapsed = LVBM.GetStatusBarTimerTimeLeft("AB_WINALLY");
						LVBM.UpdateStatusBarTimer("AB_WINALLY", nil, (timeElapsed + AllyTime), nil, true);
					else
						LVBM.StartStatusBarTimer(AllyTime, "AB_WINALLY", nil, true);
					end
				end
		end
		
		-------------------
		-- AV AutoTurnIn --
		-------------------
		if ((event == "GOSSIP_SHOW" or event=="QUEST_PROGRESS") and GetRealZoneText() == LVBM_BGMOD_LANG.AV_ZONE) then
			local target = UnitName("target");

			if( target == LVBM_BGMOD_LANG.AV_NPC.SMITHREGZAR or target == LVBM_BGMOD_LANG.AV_NPC.MURGOTDEEPFORGE ) then
				-- Open Quest to Smith or Murgot
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.ARMORSCRAPS) >= 20) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.AV_NPC.PRIMALISTTHURLOGA) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.SOLDIERSBLOOD);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.AV_NPC.ARCHDRUIDRENFERAL) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.STORMCRYSTAL);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.AV_NPC.STORMPIKERAMRIDERCOMMANDER) then	-- Ram Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.FROSTWOLFHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.AV_NPC.FROSTWOLFWOLFRIDERCOMMANDER) then	-- Wolf Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.ALTERACRAMHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end
			end

		end
		if (event=="QUEST_PROGRESS" and GetRealZoneText() == LVBM_BGMOD_LANG.AV_ZONE and LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn) then
			local target = UnitName("target");

			if (target == LVBM_BGMOD_LANG.AV_NPC.WINGCOMMANDERJEZTOR 
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.LIEUTENANTSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.AV_NPC.WINGCOMMANDERGUSE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.SOLDIERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.AV_NPC.WINGCOMMANDERMULVERICK
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.COMMANDERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.AV_NPC.WINGCOMMANDERVIPORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.LIEUTENANTSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.AV_NPC.WINDCOMMANDERSLIDORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.SOLDIERSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.AV_NPC.WINGCOMMANDERICHMAN
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.AV_ITEM.COMMANDERSMEDAL) == 0) then		return;

		   	end
			CompleteQuest();

		end
		if (event=="QUEST_COMPLETE" and GetRealZoneText() == LVBM_BGMOD_LANG.AV_ZONE and LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn) then
			local target = UnitName("target");
			for index,  value in pairs(LVBM_BGMOD_LANG.AV_NPC) do
				if (target == value) then
					GetQuestReward(0);
					LVBM.AddMsg(LVBM_BGMOD_LANG.THANKS);
				end
			end
		end


		-- ----------------- --
		-- Code from LeoLeal --
		-- modded by Nitram  --
		-- ----------------- --
		if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["AB_HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["AB_CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartColoredStatusBarTimer(64,  "Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), nil, 0, 0, 1);

					elseif string.find(arg1, LVBM_BGMOD_LANG["AB_HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["AB_HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["AB_HASTAKENTHE"]) then
							if LVBM_BGMOD_LANG["AB_TARGETS_ANNOUNCE"] and LVBM_BGMOD_LANG["AB_TARGETS_ANNOUNCE"][index] then
								LVBM.Announce(string.format(LVBM_BGMOD_LANG.ALLI_TAKE_ANNOUNCE, LVBM_BGMOD_LANG.AB_TARGETS_ANNOUNCE[index]));
							else
								LVBM.Announce(string.format(LVBM_BGMOD_LANG.ALLI_TAKE_ANNOUNCE, LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index])));
							end
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "blue";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
					end
				end
			end
			
			-- WSG Capture Flag
			if (string.find(arg1, LVBM_BGMOD_LANG["WSG_HASCAPTURED"])) then
				oldFlashColor=LVBM.Options.FlashColor;
				LVBM.Options.FlashColor = "blue";
				LVBM.AddSpecialWarning("", false, true);
				LVBM.Options.FlashColor = oldFlashColor;
				LVBM.StartStatusBarTimer(23, "Flag respawn", true);
			end
			
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartColoredStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8], nil, 0,0,1);
			end
		elseif (event == "CHAT_MSG_BG_SYSTEM_HORDE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["AB_HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["AB_CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartColoredStatusBarTimer(64, "Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), nil, 1,0,0);
					elseif string.find(arg1, LVBM_BGMOD_LANG["AB_HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["AB_HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["AB_HASTAKENTHE"]) then
							if LVBM_BGMOD_LANG["AB_TARGETS_ANNOUNCE"] and LVBM_BGMOD_LANG["AB_TARGETS_ANNOUNCE"][index] then
								LVBM.Announce(string.format(LVBM_BGMOD_LANG.HORDE_TAKE_ANNOUNCE, LVBM_BGMOD_LANG.AB_TARGETS_ANNOUNCE[index]));
							else
								LVBM.Announce(string.format(LVBM_BGMOD_LANG.HORDE_TAKE_ANNOUNCE, LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index])));
							end
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "red";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
					end
				end
			end			
			-- WSG Capture
			if (string.find(arg1,LVBM_BGMOD_LANG["WSG_HASCAPTURED"])) then
				oldFlashColor=LVBM.Options.FlashColor;
				LVBM.Options.FlashColor = "red";
				LVBM.AddSpecialWarning("", false, true);
				LVBM.Options.FlashColor = oldFlashColor;
				LVBM.StartStatusBarTimer(23, "Flag respawn", true);
			end
		
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartColoredStatusBarTimer(303, "Horde: "..LVBM_BGMOD_EN_TARGET_AV[8], nil, 1,0,0);
			end
			
		-- Alterac Valley Specific Yells
		elseif (event == "CHAT_MSG_MONSTER_YELL") then
			for index,  value in ipairs(LVBM_BGMOD_LANG["AV_TARGETS"]) do
				if string.find(string.lower(arg1), string.lower(value)) then

					if string.find(arg1, LVBM_BGMOD_LANG["AV_UNDERATTACK"]) then
						--Initiate a timer w/ value as text string for 300 seconds
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then 
							LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartColoredStatusBarTimer(303,  "Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], nil, 1,0,0);
						end
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartColoredStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], nil, 0,0,1);
						end
					elseif string.find(arg1, LVBM_BGMOD_LANG["AV_WASDESTROYED"]) or string.find(arg1, LVBM_BGMOD_LANG["AV_WASTAKENBY"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.ALLI_TAKE_ANNOUNCE, value));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "blue";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.HORDE_TAKE_ANNOUNCE, value));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "red";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
						LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
					end
				end
			end

			--Ivus and Ice Lord
			if string.find(arg1,LVBM_BGMOD_LANG["AV_IVUS"]) then 
				LVBM.StartStatusBarTimer(603,  "Ivus spawn");
			elseif string.find(string.lower(arg1),string.lower(LVBM_BGMOD_LANG["AV_ICEY"])) then
				LVBM.StartStatusBarTimer(603,  "Ice spawn");
			end

		-- Begining Match Timers and End Matches
		elseif (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
			if (arg1 == LVBM_BGMOD_LANG["WSG_START60SEC"]
			 or arg1 == LVBM_BGMOD_LANG["AB_START60SEC"]
			 or arg1 == LVBM_BGMOD_LANG["AV_START60SEC"] ) then
					LVBM.EndStatusBarTimer("Begins", true);
					LVBM.StartStatusBarTimer(62, "Begins", true);

			elseif (arg1 == LVBM_BGMOD_LANG["WSG_START30SEC"]
			     or arg1 == LVBM_BGMOD_LANG["AB_START30SEC"]
			     or arg1 == LVBM_BGMOD_LANG["AV_START30SEC"] ) then
					
					if not LVBM.GetStatusBarTimerTimeLeft("Begins") then
						LVBM.StartStatusBarTimer(62, "Begins");
					end
					LVBM.UpdateStatusBarTimer("Begins", 31, 62);
					
			elseif (arg1 == LVBM_BGMOD_LANG["ARENA_BEGIN"]) then
				LVBM.StartStatusBarTimer(60, "Begins");
			elseif (arg1 == LVBM_BGMOD_LANG["ARENA_BEGIN30"]) then
				if not LVBM.GetStatusBarTimerTimeLeft("Begins") then
					LVBM.StartStatusBarTimer(60, "Begins");
				end
				LVBM.UpdateStatusBarTimer("Begins", 30, 60);
			elseif (arg1 == LVBM_BGMOD_LANG["ARENA_BEGIN15"]) then
				if not LVBM.GetStatusBarTimerTimeLeft("Begins") then
					LVBM.StartStatusBarTimer(60, "Begins");
				end
				LVBM.UpdateStatusBarTimer("Begins", 45, 60);
			end

			-- Resets Timers when BGMatch Ends (Note that this is different than Leaving BG)
			if string.find(arg1, LVBM_BGMOD_LANG["WINS"]) then
				LVBM.EndStatusBarTimer("Flag respawn", true);
				for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
					LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
					LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
				end
				for index, value in ipairs(LVBM_BGMOD_EN_TARGET_AV) do
					LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
					LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
				end
			end

		-- Reset Timers when leaving BG
		elseif (event == "PLAYER_ENTERING_WORLD") then
			for index, value in pairs(LVBM.StatusBarData) do
				if value.bossModID == "Battlegrounds" then
					LVBM.EndRepeatingStatusBarTimer(index, true);
				end
			end
			LVBM.UnSchedule("LVBM.AddOns.Battlegrounds.OnEvent");
		end
	end, 	
	["ClassColors"] = {
		[LVBM_HUNTER] = { r = 0.67, g = 0.83, b = 0.45 },
		[LVBM_WARLOCK] = { r = 0.58, g = 0.51, b = 0.79 },
		[LVBM_PRIEST] = { r = 1.0, g = 1.0, b = 1.0 },
		[LVBM_PALADIN] = { r = 0.96, g = 0.55, b = 0.73 },
		[LVBM_MAGE] = { r = 0.41, g = 0.8, b = 0.94 },
		[LVBM_ROGUE] = { r = 1.0, g = 0.96, b = 0.41 },
		[LVBM_DRUID] = { r = 1.0, g = 0.49, b = 0.04 },
		[LVBM_SHAMAN] = { r = 0.96, g = 0.55, b = 0.73 },
		[LVBM_WARRIOR] = { r = 0.78, g = 0.61, b = 0.43 }
	},
};

 


hooksecurefunc("WorldStateScoreFrame_Update", function()
	if not LVBM.AddOns.Battlegrounds.Options.ColorByClass then
		return;
	end
	
	local isArena = IsActiveBattlefieldArena();
	local i = 1;
	while getglobal("WorldStateScoreButton"..i.."NameButtonName") do
		local index = (FauxScrollFrame_GetOffset(WorldStateScoreScrollFrame) or 0) + i;
		
		local name, _, _, _, _, faction, _, _, class = GetBattlefieldScore(index);
		if class and LVBM.AddOns.Battlegrounds.ClassColors[class] then
			getglobal("WorldStateScoreButton"..i.."NameButtonName"):SetTextColor(LVBM.AddOns.Battlegrounds.ClassColors[class].r, LVBM.AddOns.Battlegrounds.ClassColors[class].g, LVBM.AddOns.Battlegrounds.ClassColors[class].b);
			local playerName = getglobal("WorldStateScoreButton"..i.."NameButtonName"):GetText();
			if playerName then
				local _, _, playerName, playerServer = string.find(playerName, "([^%-]+)%-(.+)");
				if playerServer and playerName then
					if faction == 0 then
						if isArena then
							getglobal("WorldStateScoreButton"..i.."NameButtonName"):SetText(playerName.."|cffffffff-|r|cff19ff19"..playerServer.."|r");
						else
							getglobal("WorldStateScoreButton"..i.."NameButtonName"):SetText(playerName.."|cffffffff-|r|cffff1919"..playerServer.."|r");
						end
					else
						if isArena then
							getglobal("WorldStateScoreButton"..i.."NameButtonName"):SetText(playerName.."|cffffffff-|r|cffffd100"..playerServer.."|r");
						else
							getglobal("WorldStateScoreButton"..i.."NameButtonName"):SetText(playerName.."|cffffffff-|r|cff00adf0"..playerServer.."|r");
						end
					end
				end
			end
		end
		i = i + 1;
	end
end);