-- 
-- Hakkar v1.1
--

LVBM.AddOns.Hakkar = { 
	["Name"] = LVBM_HAKKAR_NAME,
	["Abbreviation1"] = "Hakkar", 
	["Version"] = "1.1",
	["Author"] = "La Vendetta|Nitram",
	["Description"] = LVBM_HAKKAR_INFO,
	["Instance"] = LVBM_ZG,
	["GUITab"] = LVBMGUI_TAB_20PL,
	["Options"] = {  
		["Enabled"] = true,
		["Announce"] = false,
	},
	["Sort"] = 8,
	["LastSuffer"] = 0,
	["Events"] = {
		["CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE"] = true,
	},
	["OnCombatStart"] = function(delay)
		LVBM.StartStatusBarTimer(600 - delay, "Enrage", "Interface\\Icons\\Spell_Shadow_UnholyFrenzy");
		LVBM.StartStatusBarTimer(90 - delay, "Life Drain", "Interface\\Icons\\Spell_Shadow_LifeDrain02");
		
		LVBM.Schedule(30 - delay, "LVBM.AddOns.Hakkar.OnEvent", "Warning60");
		LVBM.Schedule(45 - delay, "LVBM.AddOns.Hakkar.OnEvent", "Warning45");
		LVBM.Schedule(75 - delay, "LVBM.AddOns.Hakkar.OnEvent", "Warning15");
		
		LVBM.Schedule(120 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 8);
		LVBM.Schedule(300 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 5);
		LVBM.Schedule(480 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 2);
		LVBM.Schedule(540 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 1);
		LVBM.Schedule(570 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 0.5);
		LVBM.Schedule(585 - delay, "LVBM.AddOns.Hakkar.OnEvent", "EnrageWarning", 0.25);
	end,
	["OnCombatEnd"] = function()
		LVBM.AddOns.Hakkar.LastSuffer = 0;
		LVBM.EndStatusBarTimer("Life Drain");
		LVBM.UnSchedule("LVBM.AddOns.Hakkar.OnEvent");
	end,
	["OnEvent"] = function(event, arg1)
		if ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" ) then
			local _, _, sArg1, sArg2 = string.find(arg1, LVBM_HAKKAR_SUFFERLIFE_EXPR);
			if ( sArg1 and sArg2 and (GetTime() - LVBM.AddOns.Hakkar.LastSuffer) > 10 ) then
				LVBM.AddOns.Hakkar.LastSuffer = GetTime();

				LVBM.Announce(LVBM_HAKKAR_SUFFERLIFE_NOW);
		
				LVBM.EndStatusBarTimer("Life Drain");
				LVBM.StartStatusBarTimer(90, "Life Drain", "Interface\\Icons\\Spell_Shadow_LifeDrain02");

				LVBM.Schedule(30, "LVBM.AddOns.Hakkar.OnEvent", "Warning60");
				LVBM.Schedule(45, "LVBM.AddOns.Hakkar.OnEvent", "Warning45");
				LVBM.Schedule(75, "LVBM.AddOns.Hakkar.OnEvent", "Warning15");
			end

		elseif ( event == "Warning60" ) then
			LVBM.Announce( string.format(LVBM_HAKKAR_SUFFERLIFE_ANNOUNCE, 60) );
			
		elseif ( event == "Warning45" ) then
			LVBM.Announce( string.format(LVBM_HAKKAR_SUFFERLIFE_ANNOUNCE, 45) );

		elseif ( event == "Warning15" ) then
			LVBM.Announce( string.format(LVBM_HAKKAR_SUFFERLIFE_ANNOUNCE, 15) );
		
		elseif ( event == "EnrageWarning" and arg1 and type(arg1) == "number" ) then
			if arg1 >= 1 then
				LVBM.Announce(string.format(LVBM_HAKKAR_ENRAGE_WARNING, arg1, LVBM_MINUTES));
			else
				LVBM.Announce(string.format(LVBM_HAKKAR_ENRAGE_WARNING, arg1 * 60, LVBM_SECONDS));
			end
		elseif ( event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE" ) then
			local _, _, sArg1, sArg2 = string.find(arg1, LVBM_HAKKAR_MC_EXPR);
			if ( sArg1 and sArg2 ) then
				if sArg1 == LVBM_YOU and sArg2 == LVBM_ARE then
					sArg1 = UnitName("player");
				end
				
				LVBM.StartStatusBarTimer(20, "Next Mind Control", "Interface\\Icons\\Spell_Shadow_ShadowWordDominate");
				LVBM.StartStatusBarTimer(10, "Mind Control: "..sArg1, "Interface\\Icons\\Spell_Shadow_ShadowWordDominate");
				
				LVBM.Announce(string.format(LVBM_HAKKAR_MC_WARNING, sArg1));
			end
		end

	end,		
};
